<?php
  // Diese Seite dient als Proxi zu verschiedenen Web-IO
  // folgende Parameter knnen/mssen in der URL mitgegebben werden
  // HTTPS -> 1 oder 0, wenn 1 dann HTTPS sonst HTTP
  // IP -> IP-Adresse des Web-IO
  // PORT -> Port Nr des Web-IO (typisch = 80)
  // PW -> Passwort des Web-IO
  // COMMAND -> input, output, counter, single, outputaccess
  // MASK -> bestimmt welche Bits gesetzt werden sollen (optional und nur bei outputaccess)
  // STATE -> Bestimmt wie die Bits gesetzt werden sollen (nur bei outputaccess)
  $PROTO="http://";
  $PORT="80";
  if (!isset($_GET['COMMAND'])) {die( 'ERROR command' );} else {$COMMAND=$_GET['COMMAND'];} 
  if (!isset($_GET['IP'])) {die( 'ERROR ip' );} else {$IP=$_GET['IP'];}
  if (!isset($_GET['HTTPS'])) {$PROTO='http://';} 
  else 
  { if ($_GET['HTTPS'] == 1) 
    { $PROTO='https://';
      $PORT='443';
    } 
  }
  if (isset($_GET['PORT'])) {$PORT=$_GET['PORT'];}
  if (!isset($_GET['PW'])) {$PW="";} else {$PW=$_GET['PW'];}
  if (!isset($_GET['MASK'])) {$MASK="0FFF";} else {$MASK=$_GET['MASK'];}
  if (!isset($_GET['STATE'])) 
  { $STATE="0000";
    $MASK="0000";
  }  
  else $STATE=$_GET['STATE'];
  { if ($COMMAND == "outputaccess")
    { $URL=$PROTO.$IP.":".$PORT."/".$COMMAND."?PW=".$PW."&Mask=".$MASK."&State=".$STATE."&";
    }
    else
    { if (substr($COMMAND,0,6) == "single")
      { $URL=$PROTO.$IP.":".$PORT."/".$COMMAND;
      }
      else
      { $URL=$PROTO.$IP.":".$PORT."/".$COMMAND."?PW=".$PW."&";
      }
    }
    $ch = curl_init();
    $options = array(
      CURLOPT_URL            => $URL,
      CURLOPT_RETURNTRANSFER => true,     // return web page
      CURLOPT_HEADER         => false,    // don't return headers
      CURLOPT_ENCODING       => "",       // handle all encodings
      CURLOPT_USERAGENT      => "webio",  // who am i
      CURLOPT_CONNECTTIMEOUT => 20,      // timeout on connect
      CURLOPT_TIMEOUT        => 20,      // timeout on response
      CURLOPT_MAXREDIRS      => 1,        // stop after 10 redirects
      CURLOPT_SSL_VERIFYHOST => false,
      CURLOPT_SSL_VERIFYPEER => false,
    );
    curl_setopt_array( $ch, $options );
    $data = curl_exec($ch);
    if ($data==false)
    { die('ERROR '.$URL);
    }
    else
    { $http_status = curl_getinfo($ch, CURLINFO_HTTP_CODE);
      if ($http_status==200)
      { echo $data;
      }
      else
      { die('ERROR '.$URL.' status '.$http_status);
      }
    } 
    curl_close($ch);  
  }
?>
